--- old/usr/src/uts/common/syscall/fcntl.c	2015-08-09 12:48:11.273671856 +0300
+++ new/usr/src/uts/common/syscall/fcntl.c	2015-08-09 12:48:11.287872897 +0300
@@ -178,6 +178,13 @@
 				f_setfd(retval, FD_CLOEXEC);
 			}
 		}
+
+		if (error == 0 && fp->f_vnode != NULL) {
+			(void) VOP_IOCTL(fp->f_vnode, F_FORKED,
+				(intptr_t) p, FKIOCTL,
+				kcred, NULL, NULL);
+		}
+
 		goto done;
 
 	case F_DUP2FD_CLOEXEC:
@@ -214,6 +221,15 @@
 			fp->f_count++;
 			mutex_exit(&fp->f_tlock);
 			releasef(fdes);
+
+			/* assume we have forked successfully */
+
+			if (fp->f_vnode != NULL) {
+				(void) VOP_IOCTL(fp->f_vnode, F_FORKED,
+					(intptr_t) p, FKIOCTL,
+					kcred, NULL, NULL);
+			}
+
 			if ((error = closeandsetf(iarg, fp)) == 0) {
 				if (cmd == F_DUP2FD_CLOEXEC) {
 					f_setfd(iarg, FD_CLOEXEC);
@@ -224,6 +240,12 @@
 				if (fp->f_count > 1) {
 					fp->f_count--;
 					mutex_exit(&fp->f_tlock);
+					if (fp->f_vnode != NULL) {
+						VOP_IOCTL(fp->f_vnode, F_CLOSED,
+							(intptr_t) p, FKIOCTL,
+							kcred, NULL, NULL);
+					}
+
 				} else {
 					mutex_exit(&fp->f_tlock);
 					(void) closef(fp);
